//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System.Linq;
using Tecan.Sila2;
using Tecan.Sila2.Client;
using Tecan.Sila2.Server;

namespace Tecan.Sila2.Interop.Server.CancellationTest
{
    
    
    /// <summary>
    /// A class that exposes the ICancellationTest interface via SiLA2
    /// </summary>
    [System.ComponentModel.Composition.ExportAttribute(typeof(IFeatureProvider))]
    [System.ComponentModel.Composition.PartCreationPolicyAttribute(System.ComponentModel.Composition.CreationPolicy.Shared)]
    public partial class CancellationTestProvider : IFeatureProvider
    {
        
        private ICancellationTest _implementation;
        
        private Tecan.Sila2.Server.ISiLAServer _server;
        
        private static Tecan.Sila2.Feature _feature = FeatureSerializer.LoadFromAssembly(typeof(CancellationTestProvider).Assembly, "CancellationTest.sila.xml");
        
        /// <summary>
        /// Creates a new instance
        /// </summary>
        /// <param name="implementation">The implementation to exported through SiLA2</param>
        /// <param name="server">The SiLA2 server instance through which the implementation shall be exported</param>
        [System.ComponentModel.Composition.ImportingConstructorAttribute()]
        public CancellationTestProvider(ICancellationTest implementation, Tecan.Sila2.Server.ISiLAServer server)
        {
            _implementation = implementation;
            _server = server;
        }
        
        /// <summary>
        /// The feature that is exposed by this feature provider
        /// </summary>
        /// <returns>A feature object</returns>
        public Tecan.Sila2.Feature FeatureDefinition
        {
            get
            {
                return _feature;
            }
        }
        
        private System.Exception ConvertWaitForCancelExceptions(System.Exception exception)
        {
            try
            {
                throw exception;
            } catch (System.ArgumentException ex)
            {
                if ((ex.ParamName == "duration"))
                {
                    throw _server.ErrorHandling.CreateValidationError("org.silastandard/test/CancellationTest/v1/Command/WaitForCancel/Parameter/Duratio" +
                            "n", ex.Message);
                }
                throw _server.ErrorHandling.CreateUnknownValidationError(ex);
            } catch (ShouldHaveBeenCancelledException ex)
            {
                throw _server.ErrorHandling.CreateExecutionError("org.silastandard/test/CancellationTest/v1/DefinedExecutionError/ShouldHaveBeenCan" +
                        "celled", "Happens if the command did not receive a cancellation", ex.Message);
            }
        }
        
        /// <summary>
        /// Registers the feature in the provided feature registration
        /// </summary>
        /// <param name="registration">The registration component to which the feature should be registered</param>
        public void Register(IServerBuilder registration)
        {
            registration.RegisterObservableCommand<WaitForCancelRequestDto>("WaitForCancel", WaitForCancel, ConvertWaitForCancelExceptions);
        }
        
        /// <summary>
        /// Executes the Wait For Cancel command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual Tecan.Sila2.IObservableCommand WaitForCancel(WaitForCancelRequestDto request)
        {
            request.Validate();
            return _implementation.WaitForCancel(request.Duration.TryExtract(_server, "org.silastandard/test/CancellationTest/v1/Command/WaitForCancel/Parameter/Duratio" +
                        "n"));
        }
        
        /// <summary>
        /// Gets the command with the given identifier
        /// </summary>
        /// <param name="commandIdentifier">A fully qualified command identifier</param>
        /// <returns>A method object or null, if the command is not supported</returns>
        public System.Reflection.MethodInfo GetCommand(string commandIdentifier)
        {
            if ((commandIdentifier == "org.silastandard/test/CancellationTest/v1/Command/WaitForCancel"))
            {
                return typeof(ICancellationTest).GetMethod("WaitForCancel");
            }
            return null;
        }
        
        /// <summary>
        /// Gets the property with the given identifier
        /// </summary>
        /// <param name="propertyIdentifier">A fully qualified property identifier</param>
        /// <returns>A property object or null, if the property is not supported</returns>
        public System.Reflection.PropertyInfo GetProperty(string propertyIdentifier)
        {
            return null;
        }
    }
}

